/* tslint:disable */
/* eslint-disable */
/**
 * Coscine Web API
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import type { Configuration } from '../../configuration';
import type { AxiosPromise, AxiosInstance, RawAxiosRequestConfig } from 'axios';
import globalAxios from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, type RequestArgs, BaseAPI, RequiredError, operationServerMap } from '../../base';
// @ts-ignore
import type { PidDtoPagedResponse } from '../../@coscine/model';
// @ts-ignore
import type { PidDtoResponse } from '../../@coscine/model';
// @ts-ignore
import type { PidRequestDto } from '../../@coscine/model';
/**
 * PidApi - axios parameter creator
 * @export
 */
export const PidApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2PidsOptions: async (options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v2/pids`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'OPTIONS', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Retrieves the Persistent Identifier (PID) for a given prefix and suffix.
         * @param {string} prefix The PID prefix. Limited to the values provided by the API.
         * @param {string} suffix The PID suffix of a project or a resource, represented as a GUID.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getPid: async (prefix: string, suffix: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'prefix' is not null or undefined
            assertParamExists('getPid', 'prefix', prefix)
            // verify required parameter 'suffix' is not null or undefined
            assertParamExists('getPid', 'suffix', suffix)
            const localVarPath = `/api/v2/pids/{prefix}/{suffix}`
                .replace(`{${"prefix"}}`, encodeURIComponent(String(prefix)))
                .replace(`{${"suffix"}}`, encodeURIComponent(String(suffix)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
         * @summary Retrieves all PIDs.
         * @param {boolean} [includeProjects] Gets or sets a value indicating whether to include projects when retrieving pid information.
         * @param {boolean} [includeResources] Gets or sets a value indicating whether to include resources when retrieving pid information.
         * @param {boolean} [includeDeleted] Gets or sets a value indicating whether to include deleted pid information.
         * @param {number} [pageNumber] The desired page number. Should be greater than or equal to 1. Default is 1.
         * @param {number} [pageSize] The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
         * @param {string} [orderBy] Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getPids: async (includeProjects?: boolean, includeResources?: boolean, includeDeleted?: boolean, pageNumber?: number, pageSize?: number, orderBy?: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v2/pids`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)

            if (includeProjects !== undefined) {
                localVarQueryParameter['IncludeProjects'] = includeProjects;
            }

            if (includeResources !== undefined) {
                localVarQueryParameter['IncludeResources'] = includeResources;
            }

            if (includeDeleted !== undefined) {
                localVarQueryParameter['IncludeDeleted'] = includeDeleted;
            }

            if (pageNumber !== undefined) {
                localVarQueryParameter['PageNumber'] = pageNumber;
            }

            if (pageSize !== undefined) {
                localVarQueryParameter['PageSize'] = pageSize;
            }

            if (orderBy !== undefined) {
                localVarQueryParameter['OrderBy'] = orderBy;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Sends an inquiry to the owner of the given PID.
         * @param {string} prefix The PID prefix of a project or a resource to validate
         * @param {string} suffix The PID body of a project or a resource to validate
         * @param {PidRequestDto} [pidRequestDto] The data transfer object containing the inquiry details.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        sendRequestToOwner: async (prefix: string, suffix: string, pidRequestDto?: PidRequestDto, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'prefix' is not null or undefined
            assertParamExists('sendRequestToOwner', 'prefix', prefix)
            // verify required parameter 'suffix' is not null or undefined
            assertParamExists('sendRequestToOwner', 'suffix', suffix)
            const localVarPath = `/api/v2/pids/{prefix}/{suffix}/requests`
                .replace(`{${"prefix"}}`, encodeURIComponent(String(prefix)))
                .replace(`{${"suffix"}}`, encodeURIComponent(String(suffix)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(pidRequestDto, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * PidApi - functional programming interface
 * @export
 */
export const PidApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = PidApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV2PidsOptions(options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV2PidsOptions(options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['PidApi.apiV2PidsOptions']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Retrieves the Persistent Identifier (PID) for a given prefix and suffix.
         * @param {string} prefix The PID prefix. Limited to the values provided by the API.
         * @param {string} suffix The PID suffix of a project or a resource, represented as a GUID.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getPid(prefix: string, suffix: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PidDtoResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getPid(prefix, suffix, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['PidApi.getPid']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
         * @summary Retrieves all PIDs.
         * @param {boolean} [includeProjects] Gets or sets a value indicating whether to include projects when retrieving pid information.
         * @param {boolean} [includeResources] Gets or sets a value indicating whether to include resources when retrieving pid information.
         * @param {boolean} [includeDeleted] Gets or sets a value indicating whether to include deleted pid information.
         * @param {number} [pageNumber] The desired page number. Should be greater than or equal to 1. Default is 1.
         * @param {number} [pageSize] The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
         * @param {string} [orderBy] Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getPids(includeProjects?: boolean, includeResources?: boolean, includeDeleted?: boolean, pageNumber?: number, pageSize?: number, orderBy?: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PidDtoPagedResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getPids(includeProjects, includeResources, includeDeleted, pageNumber, pageSize, orderBy, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['PidApi.getPids']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Sends an inquiry to the owner of the given PID.
         * @param {string} prefix The PID prefix of a project or a resource to validate
         * @param {string} suffix The PID body of a project or a resource to validate
         * @param {PidRequestDto} [pidRequestDto] The data transfer object containing the inquiry details.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async sendRequestToOwner(prefix: string, suffix: string, pidRequestDto?: PidRequestDto, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.sendRequestToOwner(prefix, suffix, pidRequestDto, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['PidApi.sendRequestToOwner']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
    }
};

/**
 * PidApi - factory interface
 * @export
 */
export const PidApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = PidApiFp(configuration)
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2PidsOptions(options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.apiV2PidsOptions(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Retrieves the Persistent Identifier (PID) for a given prefix and suffix.
         * @param {PidApiGetPidRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getPid(requestParameters: PidApiGetPidRequest, options?: RawAxiosRequestConfig): AxiosPromise<PidDtoResponse> {
            return localVarFp.getPid(requestParameters.prefix, requestParameters.suffix, options).then((request) => request(axios, basePath));
        },
        /**
         * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
         * @summary Retrieves all PIDs.
         * @param {PidApiGetPidsRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getPids(requestParameters: PidApiGetPidsRequest = {}, options?: RawAxiosRequestConfig): AxiosPromise<PidDtoPagedResponse> {
            return localVarFp.getPids(requestParameters.includeProjects, requestParameters.includeResources, requestParameters.includeDeleted, requestParameters.pageNumber, requestParameters.pageSize, requestParameters.orderBy, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Sends an inquiry to the owner of the given PID.
         * @param {PidApiSendRequestToOwnerRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        sendRequestToOwner(requestParameters: PidApiSendRequestToOwnerRequest, options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.sendRequestToOwner(requestParameters.prefix, requestParameters.suffix, requestParameters.pidRequestDto, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for getPid operation in PidApi.
 * @export
 * @interface PidApiGetPidRequest
 */
export interface PidApiGetPidRequest {
    /**
     * The PID prefix. Limited to the values provided by the API.
     * @type {string}
     * @memberof PidApiGetPid
     */
    readonly prefix: string

    /**
     * The PID suffix of a project or a resource, represented as a GUID.
     * @type {string}
     * @memberof PidApiGetPid
     */
    readonly suffix: string
}

/**
 * Request parameters for getPids operation in PidApi.
 * @export
 * @interface PidApiGetPidsRequest
 */
export interface PidApiGetPidsRequest {
    /**
     * Gets or sets a value indicating whether to include projects when retrieving pid information.
     * @type {boolean}
     * @memberof PidApiGetPids
     */
    readonly includeProjects?: boolean

    /**
     * Gets or sets a value indicating whether to include resources when retrieving pid information.
     * @type {boolean}
     * @memberof PidApiGetPids
     */
    readonly includeResources?: boolean

    /**
     * Gets or sets a value indicating whether to include deleted pid information.
     * @type {boolean}
     * @memberof PidApiGetPids
     */
    readonly includeDeleted?: boolean

    /**
     * The desired page number. Should be greater than or equal to 1. Default is 1.
     * @type {number}
     * @memberof PidApiGetPids
     */
    readonly pageNumber?: number

    /**
     * The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
     * @type {number}
     * @memberof PidApiGetPids
     */
    readonly pageSize?: number

    /**
     * Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
     * @type {string}
     * @memberof PidApiGetPids
     */
    readonly orderBy?: string
}

/**
 * Request parameters for sendRequestToOwner operation in PidApi.
 * @export
 * @interface PidApiSendRequestToOwnerRequest
 */
export interface PidApiSendRequestToOwnerRequest {
    /**
     * The PID prefix of a project or a resource to validate
     * @type {string}
     * @memberof PidApiSendRequestToOwner
     */
    readonly prefix: string

    /**
     * The PID body of a project or a resource to validate
     * @type {string}
     * @memberof PidApiSendRequestToOwner
     */
    readonly suffix: string

    /**
     * The data transfer object containing the inquiry details.
     * @type {PidRequestDto}
     * @memberof PidApiSendRequestToOwner
     */
    readonly pidRequestDto?: PidRequestDto
}

/**
 * PidApi - object-oriented interface
 * @export
 * @class PidApi
 * @extends {BaseAPI}
 */
export class PidApi extends BaseAPI {
    /**
     * 
     * @summary Responds with the HTTP methods allowed for the endpoint.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PidApi
     */
    public apiV2PidsOptions(options?: RawAxiosRequestConfig) {
        return PidApiFp(this.configuration).apiV2PidsOptions(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Retrieves the Persistent Identifier (PID) for a given prefix and suffix.
     * @param {PidApiGetPidRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PidApi
     */
    public getPid(requestParameters: PidApiGetPidRequest, options?: RawAxiosRequestConfig) {
        return PidApiFp(this.configuration).getPid(requestParameters.prefix, requestParameters.suffix, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
     * @summary Retrieves all PIDs.
     * @param {PidApiGetPidsRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PidApi
     */
    public getPids(requestParameters: PidApiGetPidsRequest = {}, options?: RawAxiosRequestConfig) {
        return PidApiFp(this.configuration).getPids(requestParameters.includeProjects, requestParameters.includeResources, requestParameters.includeDeleted, requestParameters.pageNumber, requestParameters.pageSize, requestParameters.orderBy, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Sends an inquiry to the owner of the given PID.
     * @param {PidApiSendRequestToOwnerRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PidApi
     */
    public sendRequestToOwner(requestParameters: PidApiSendRequestToOwnerRequest, options?: RawAxiosRequestConfig) {
        return PidApiFp(this.configuration).sendRequestToOwner(requestParameters.prefix, requestParameters.suffix, requestParameters.pidRequestDto, options).then((request) => request(this.axios, this.basePath));
    }
}

